#ifndef _TMAFILEREADER_HPP_
#define _TMAFILEREADER_HPP_

#include "../ma_object.hpp"
#include "tmastring.hpp"
#include <stdio.h>

// **********************************************
// Interfaz para clases que trabajan con ficheros
// **********************************************
//
class TMAFileReader : public TMAObject
{
    REGISTER_CLASS protected:
        
    public:
        PUBLIC_CLASS_ID;
    
        long getCurrentOffset(FILE*);
        bool seekTo(FILE*,long);
        long getBytes(FILE *,void *,long size);
        unsigned char getByte(FILE*);
        unsigned int  get2BWord(FILE*);
        int  get2BWordSigned(FILE*);
        unsigned long get4BWord(FILE*);
        TMAString getString(FILE*,int size);        
    
        virtual bool readFromFile(FILE*)=0;
};

typedef TMAFileReader* PMAFileReader;

#endif
