#ifndef _TMASTRINGDICTIONARY_CPP_
#define _TMASTRINGDICTIONARY_CPP_

#include "tmastringdictionary.hpp"
#include "../tad/tmavector.cpp"

REGISTER_CLASS_ID(TMAStringDictionaryEntry);
REGISTER_CLASS_ID(TMAStringDictionaryEntryComparator);
REGISTER_CLASS_ID(TMAStringDictionary);

TMAStringDictionary::TMAStringDictionary():TMAVectorOrdered<TMAStringDictionaryEntry>()
{
    this->setComparator(new TMAStringDictionaryEntryComparator());
}

#endif
